 #include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>

FILE *pf1, *pf2, *pf3, *pf4, *pf5,*pf6,*pf7;

float ran2(long int*);
int i,j,k,a,N = 2, nbredefois = 100000 ;
int compteur,compteurk;
int iout, mod;
int L = 51; //sur un intervalle de [-4,4]

double P, newP, newX, intervalle;
long int idum = -1833;

int numeroX0, numeroX1;
double pas, xy;

int main() {
    
    pf2 = fopen("traj.txt","w");
    pf3 = fopen("grille.txt","w");
    pf4 = fopen("trajsup.txt","w");
    pf5 = fopen("trajinf.txt","w");
    pf6 = fopen("coupexy.txt","w");
    pf7 = fopen("coupexytheorie.txt","w");
    
    
    pas = 8.0/L;
    printf("pas %f\n",pas);
    double x[N];
    double grille[L][L];
    double trajsup[nbredefois][2];
    double trajinf[nbredefois][2];
    double trajsup2[nbredefois][2];
    double trajinf2[nbredefois][2];
    
    int compteursup, compteurinf;
    double moysupx, moysupy, moyinfx, moyinfy, moysup2x, moysup2y,moyinf2x,moyinf2y;
    
    compteursup = compteurinf = 0 ;
    moysupx = moysupy = moyinfx = moyinfy = moysup2x = moysup2y = moyinf2x = moyinf2y = 0;
    
    //init de la grille,  //
    for(i=0;i<L;i++){
        for(j=0;j<L;j++){
            grille[i][j] = 0;
        }
    }
    
    
    
    compteur = compteurk = 0;
    mod = 100;
    
    
    
    //Distribution initiale des particules//
    x[0] = -1.0;
    for(i=1;i<N;i++){
        x[i]= x[i-1] + 2.0/(N-1);
        printf("%f\n",x[i]);
    }
    
    
    //Calcul de la proba de la config initiale//
    
    P = 1; //initialisation de la proba
    for(i=0;i<N;i++){
        for(j=i+1;j<N;j++){
            P = P * (x[i]-x[j]) * (x[i]-x[j]);
        }
        P = P * exp(-x[i]*x[i]);
    }
    
    //Calcul des nouvelles proba avec nouvelles config//
    
    for(k=0;k<nbredefois;k++){
        for(i=0;i<N;i++){
            newX = x[i] + 2*(ran2(&idum))-1;
            newP = P * exp(-newX*newX)/exp(-x[i]*x[i]);
            
            for(j=0;j<N;j++){
                if(i==j) continue;
                newP = newP * ((newX-x[j])*(newX-x[j]))/((x[i]-x[j])*(x[i]-x[j]));
            }
            if(P/newP <= 1 | ran2(&idum) <= newP/P){
                compteur = compteur + 1;
                x[i] = newX ;
                P = newP ;
            }
        }
        
        //GRILLE//
        // If N=2 on cherche l'histogramme de la densité de proba//
        for(i=0;i<L;i++){
            if(-4+i*pas <= x[0] && x[0] <= -4+(i+1)*pas){
                numeroX0 = i;
            }
        }
        
        for(i=0;i<L;i++){
            if(4-i*pas >= x[1] && x[1] >= 4-(i+1)*pas){
                numeroX1 = i;
            }
        }
        
        grille[numeroX0][numeroX1] = grille[numeroX0][numeroX1] + 1;
        
        //if(compteurk%mod==0){
        //Locate :(traj dans différents dossiers)//
        /*char fname[256];
         sprintf(fname,"locate_%04d",iout);
         iout = iout + 1;
         pf1 = fopen(fname,"w");
         
         for(i=0; i<N ; i++) {
         fprintf(pf1,"%f\n",x[i]) ;
         }
         fclose(pf1);
         */
        /* //TRAJ CLASSIQUE//
         for(i=0 ; i<N ; i++){
         fprintf(pf2,"%f ",x[i]);
         }
         fprintf(pf2,"\n");
         }
         compteurk = compteurk +1;*/
        
        /*
        //TRAJSUP TRAJINF POUR 2 FERMIONS//
        
        if(x[0]>x[1]){
            trajsup[k][0] = x[0];
            trajsup[k][1] = x[1];
            trajsup2[k][0] = x[0];
            trajsup2[k][1] = x[1];
            fprintf(pf4, "%f %f\n", x[0], x[1]);
            compteursup = compteursup+1;
        }
        else{
            trajinf[k][0] = x[0];
            trajinf[k][1] = x[1];
            trajinf2[k][0] = x[0];
            trajinf2[k][1] = x[1];
            fprintf(pf5, "%f %f\n", x[0], x[1]);
            compteurinf = compteurinf+1;
        }*/
        
    }
    /*
    for(i=0;i<nbredefois;i++){
        moysupx = moysupx + trajsup[i][0];
        moysupy = moysupy + trajsup[i][1];
        moyinfx = moyinfx + trajinf[i][0];
        moyinfy = moyinfy + trajinf[i][1];
    }
    
    for(i=0;i<nbredefois;i++){
        moysup2x = moysup2x + trajsup2[i][0]*trajsup2[i][0];
        moysup2y = moysup2y + trajsup2[i][1]*trajsup2[i][1];
        moyinf2x = moyinf2x + trajinf2[i][0]*trajinf2[i][0];
        moyinf2y = moyinf2y + trajinf2[i][1]*trajinf2[i][1];
         
    }

    moysupx = moysupx/compteursup;
    moysupy = moysupy/compteursup;
    moyinfx = moyinfx/compteurinf;
    moyinfy = moyinfy/compteurinf;
    
    moysup2x = moysup2x/compteursup;
    moysup2y = moysup2y/compteursup;
    moyinf2x = moyinf2x/compteurinf;
    moyinf2y = moyinf2y/compteurinf;
    
    
    //print des moyennes et leurs écart-type //
    printf("1ere particule (%f +_ %f) ; (%f +_ %f)\n2eme particule (%f +_ %f) ; (%f +_ %f)\n",moysupx,sqrt(moysup2x-moysupx*moysupx), moysupy, sqrt(moysup2y-moysupy*moysupy), moyinfx,sqrt(moyinf2x-moyinfx*moyinfx), moyinfy,sqrt(moyinf2y-moyinfy*moyinfy));
    */
    
    printf("stat d'acceptation de config : %f\n", 1.0*compteur/N/nbredefois);

    
    //GRILLE//
    for(i=0 ; i<L ; i++){
        for(j=0;j<L;j++){
            grille[i][j]= grille[i][j]/nbredefois;
        }
    }
    
    for(i=0;i<L;i++){
        for(j=0;j<L;j++){
            if(j==i){
                fprintf(pf6,"%f %f %f\n", (-4+j*pas-4+(j+1)*pas)/2, (4-i*pas+4-(i+1)*pas)/2, grille[i][j]); //printf (x1, x2, grille)
            }
        }
    }
    
    for(i=0;i<L;i++){
        for(j=0;j<L;j++){
            fprintf(pf3,"%f ", grille[i][j]);
        }
        fprintf(pf3,"\n");
        
    }
    
    //Courbe Theorique Densite x1=-x2//
    for(i=0;i<L;i++){
        xy = (-4+i*pas-4+(i+1)*pas)/2;
        fprintf(pf7,"%f %f\n", xy,4.0*xy*xy*exp(-2.0*xy*xy));
        
    }
    
    fclose(pf2);
    fclose(pf3);
    
    fclose(pf4);
    fclose(pf5);
    fclose(pf6);
    fclose(pf7);
    
}//end main