#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>

FILE *pf22,*pf2,*pf23,*pf24,*pf25;

float ran2(long int*);
int i,j,k,l,a,N = 20, nbredefois = 33333333 ;
int compteur;
int iout, mod;
int M = 1001; //sur un intervalle de [-4,4]

double P, newP, newX, intervalle;
long int idum = -1833;


double pas;

int main() {
    
    pf2 = fopen("traj.txt","w");
    pf22 = fopen("histdensite.txt","w");
    pf23 = fopen("fctcomptage.txt","w");
    pf24 = fopen("histo_uniforme.txt","w");
    pf25 = fopen("traj_uniforme.txt","w");
    
    
    double xmax = 8.0 ;
    double xmin = -xmax;
    double x[N];
    double histdensite[M];
    double fctcomptage[M];
    double unihistdensite[(M+11)/16];
    pas = (xmax-xmin)/M;
    printf("pas %f\n",pas);
    
    //initialisation de histdensite//
    for(i=0;i<M;i++){
        histdensite[i] = 0;
        fctcomptage[i] = 0;
        unihistdensite[i] = 0;
    }
    
    
    
    compteur = 0;
    mod = 10;
    
    
    
    //Distribution initiale des particules//
    x[0] = -1.0;
    for(i=1;i<N;i++){
        x[i]= x[i-1] - 2.0*x[0]/(N-1);
        printf("%f\n",x[i]);
    }
    
    
    //Calcul de la proba de la config initiale//
    
    P = 1; //initialisation de la proba
    for(i=0;i<N;i++){
        for(j=i+1;j<N;j++){
            P = P * (x[i]-x[j]) * (x[i]-x[j]);
        }
        P = P * exp(-x[i]*x[i]);
    }
    
    //Calcul des nouvelles proba avec nouvelles config//
    
    
    for(k=0;k<nbredefois;k++){
        for(i=0;i<N;i++){
            newX = x[i] + 2*(ran2(&idum))-1;
            newP = P * exp(-newX*newX)/exp(-x[i]*x[i]);
            
            for(j=0;j<N;j++){
                if(i==j) continue;
                newP = newP * ((newX-x[j])*(newX-x[j]))/((x[i]-x[j])*(x[i]-x[j]));
            }
            if(P/newP <= 1 | ran2(&idum) <= newP/P){
                compteur = compteur + 1;
                x[i] = newX ;
                P = newP ;
            }
            
        }
        
        if(k%mod==0){
        if(k>=nbredefois/10){ //thermalisation
            
            //TRAJ CLASSIQUE//
            for(i=0 ; i<N ; i++){
                fprintf(pf2,"%f ",x[i]);
            }
            fprintf(pf2,"\n");
            
            
            for(i=0;i<N;i++){
                for(j=0;j<M;j++){
                    if(xmin+j*pas <= x[i] && x[i] <= xmin+(j+1)*pas)
                        histdensite[j] = histdensite[j] + 1 ;
                    if(xmin <= x[i] && x[i] <= xmin+(j+1)*pas)
                        fctcomptage[j] = fctcomptage[j] + 1 ;
                }
            }
        }//endif thermalisation
        }//endif décorrélation
    }//endfor k
    printf("stat d'acceptation de config : %f\n", 1.0*compteur/N/nbredefois);
    
    
    
    
    for(i=0;i<M;i++){
        fprintf(pf22,"%f %f\n",(xmin+i*pas+xmin+(i+1)*pas)/2, histdensite[i]/((nbredefois-nbredefois/10)/mod)/N);
        fprintf(pf23,"%f %f\n",(xmin+i*pas+xmin+(i+1)*pas)/2, fctcomptage[i]/((nbredefois-nbredefois/10)/mod));
        
    }
    fclose(pf2);
    pf2 = fopen("traj.txt","r");
   
    for(i=0;i<((nbredefois-nbredefois/10))/mod; i++){
        for(j=0;j<N;j++){

            fscanf(pf2,"%lf ",&x[j]);
            
            //printf("ancienne valeur x[j] : %lf\n",x[j]);
            for(l=0;l<M;l++){
                
                if(xmin+l*pas <= x[j] && x[j] <= xmin+(l+1)*pas){
                    
                    x[j] = fctcomptage[l];
                    //printf("fctcomptage [l] : %lf\n ",fctcomptage[l]);
                    //printf("nouvelle valeur x[j] : %lf\n ",x[j]);
                }//endif
            }//endfor l
            
            fprintf(pf25,"%lf ",x[j]/(double)((nbredefois-nbredefois/10)/mod));
            
        }//endfor j
        //printf("%lf\n",x[0]);
        fscanf(pf2,"\n");
        fprintf(pf25,"\n");
        
        for(j=0;j<N;j++){
            x[j] = x[j]/(double)((nbredefois-nbredefois/10)/mod);
            //printf("x[j] : %lf\n",x[j]);
        }
        
        for(j=0;j<N;j++){
            for(l=0;l<(M+11)/16;l++){
                if(l*(double)N/(double)((M+11)/16) <= x[j] && x[j] <= (l+1)*(double)N/(double)((M+11)/16)){
                    unihistdensite[l] = unihistdensite[l] + 1 ;
                }//endif
            }//endfor l
        }//endfor j
    }//endfor i
    
    //for(l=0;l<M;l++){
       // printf("unihistdensite[l] : %lf\n",unihistdensite[l]);
    //}
    



    
    for(i=0;i<((M+11)/16);i++){
        fprintf(pf24,"%f %f\n",(i*(double)N/(double)((M+11)/16)+(i+1)*(double)N/(double)((M+11)/16))/2, unihistdensite[i]);///(nbredefois-nbredefois/10)/N);
    }
    
    
    
    
    
    
    
    
    fclose(pf2);
    fclose(pf22);
    fclose(pf23);
    fclose(pf24);
    fclose(pf25);
    
    
    
}//end main