#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>

FILE *pf1, *pf2, *pf3;

float ran2(long int*);
int i,j,k,a,N = 2, nbredefois = 100000 ;
int compteur,compteurk;
int iout, mod;
int L = 51; //sur un intervalle de [-4,4]

double P, newP, newX, intervalle;
long int idum = -1833;

int numeroX0, numeroX1;
double pas;

int main() {
    
    pf2 = fopen("traj.txt","w");
    pf3 = fopen("grille.txt","w");
    
    
    pas = 8.0/L;
    printf("pas %f\n",pas);
    double x[N];
    double grille[L][L];
    
    
    
    //init de la grille //
    for(i=0;i<L;i++){
        for(j=0;j<L;j++){
            grille[i][j] = 0;
        }
    }
    
    
    
    compteur = compteurk = 0;
    mod = 100;
    
    
    
    //Distribution initiale des particules//
    x[0] = -1.0;
    for(i=1;i<N;i++){
        x[i]= x[i-1] + 2.0/(N-1);
        printf("%f\n",x[i]);
    }
    
    
    //Calcul de la proba de la config initiale//
    
    P = 1; //initialisation de la proba
    for(i=0;i<N;i++){
        for(j=i+1;j<N;j++){
            P = P * (x[i]-x[j]) * (x[i]-x[j]);
        }
        P = P * exp(-x[i]*x[i]);
    }
    
    //Calcul des nouvelles proba avec nouvelles config//
    
    for(k=0;k<nbredefois;k++){
        for(i=0;i<N;i++){
            newX = x[i] + 2*(ran2(&idum))-1;
            newP = P * exp(-newX*newX)/exp(-x[i]*x[i]);
            
            for(j=0;j<N;j++){
                if(i==j) continue;
                newP = newP * ((newX-x[j])*(newX-x[j]))/((x[i]-x[j])*(x[i]-x[j]));
            }
            if(P/newP <= 1 | ran2(&idum) <= newP/P){
                compteur = compteur + 1;
                x[i] = newX ;
                P = newP ;
            }
        }
        
        //GRILLE//
        // If N=2 on cherche l'histogramme de la densité de proba//
        for(i=0;i<L;i++){
            if(-4+i*pas <= x[0] && x[0] <= -4+(i+1)*pas){
                numeroX0 = i;
            }
        }
        
        for(i=0;i<L;i++){
            if(4-i*pas >= x[1] && x[1] >= 4-(i+1)*pas){
                numeroX1 = i;
            }
        }
        
        grille[numeroX0][numeroX1] = grille[numeroX0][numeroX1] + 1;
        
        //if(compteurk%mod==0){
        //Locate :(traj dans différents dossiers)//
        /*char fname[256];
         sprintf(fname,"locate_%04d",iout);
         iout = iout + 1;
         pf1 = fopen(fname,"w");
         
         for(i=0; i<N ; i++) {
         fprintf(pf1,"%f\n",x[i]) ;
         }
         fclose(pf1);
         */
         //TRAJ CLASSIQUE//
         for(i=0 ; i<N ; i++){
         fprintf(pf2,"%f ",x[i]);
         }
         fprintf(pf2,"\n");
         
         compteurk = compteurk +1;
        
        
         
    }
        printf("stat d'acceptation de config : %f\n", 1.0*compteur/N/nbredefois);

    
    //GRILLE//
    for(i=0 ; i<L ; i++){
        for(j=0;j<L;j++){
            grille[i][j]= grille[i][j]/nbredefois;
        }
    }
    
    
    for(i=0;i<L;i++){
        for(j=0;j<L;j++){
            fprintf(pf3,"%f ", grille[i][j]);
        }
        fprintf(pf3,"\n");
        
    }
    
    
    fclose(pf2);
    fclose(pf3);
    

    
}//end main