#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>

FILE *pf7, *pf9, *pf10, *pf11,*pf12, *pf13, *pf14,*pf15, *pf16, *pf17,*pf18,*pf19,*pf20,*pf21 ;

float ran2(long int*);
int i,j,k,a,N = 2, nbredefois = 100000000 ;
int compteur,compteurk;
int iout, mod;
int L = 101; //sur un intervalle de [-4,4]

double P, newP, newX, intervalle;
long int idum = -1833;

int numeroX0, numeroX1;
double pas;
double moyennecarre;
double xy;



int main() {
    

    pf7 = fopen("courbetheorique.txt","w");
    pf9 = fopen("grille1.txt","w");
    pf10 = fopen("grille2.txt","w");
    pf11 = fopen("grille3.txt","w");
    pf12 = fopen("grille4.txt","w");
    pf13 = fopen("grille5.txt","w");
    pf14 = fopen("grille6.txt","w");
    pf15 = fopen("grille7.txt","w");
    pf16 = fopen("grille8.txt","w");
    pf17 = fopen("grille9.txt","w");
    pf18 = fopen("grille10.txt","w");
    pf19 = fopen("grillemoy.txt","w");
    pf20 = fopen("grilleET.txt","w");
    pf21 = fopen("coupeincert.txt","w");
    
    
    double taillegrilles = (nbredefois-nbredefois/10)/10;
    pas = 8.0/L;
    printf("pas %f\n",pas);
    double x[N];
    double grille1[L][L];
    double grille2[L][L];
    double grille3[L][L];
    double grille4[L][L];
    double grille5[L][L];
    double grille6[L][L];
    double grille7[L][L];
    double grille8[L][L];
    double grille9[L][L];
    double grille10[L][L];
    
    double grillemoy[L][L];
    double grilleET[L][L];
    
    double fctx[L], fctxexp[L];
    double incertmoy = 0, fctmoy = 0, incertmoypourcent=0.0;
    
    //init de la grille //
    for(i=0;i<L;i++){
        for(j=0;j<L;j++){
            grille1[i][j] = 0;
            grille2[i][j] = 0;
            grille3[i][j] = 0;
            grille4[i][j] = 0;
            grille5[i][j] = 0;
            grille6[i][j] = 0;
            grille7[i][j] = 0;
            grille8[i][j] = 0;
            grille9[i][j] = 0;
            grille10[i][j] = 0;
            grillemoy[i][j] = 0;
            grilleET[i][j] = 0;
        }
    }
    
    
    
    compteur = compteurk = 0;
    mod = 100;
    
    
    
    //Distribution initiale des particules//
    x[0] = -1.0;
    for(i=1;i<N;i++){
        x[i]= x[i-1] + 2.0/(N-1);
        printf("%f\n",x[i]);
    }
    
    
    //Calcul de la proba de la config initiale//
    
    P = 1; //initialisation de la proba
    for(i=0;i<N;i++){
        for(j=i+1;j<N;j++){
            P = P * (x[i]-x[j]) * (x[i]-x[j]);
        }
        P = P * exp(-x[i]*x[i]);
    }
    
    //Calcul des nouvelles proba avec nouvelles config//
    
    for(k=0;k<nbredefois;k++){
        for(i=0;i<N;i++){
            newX = x[i] + 2*(ran2(&idum))-1;
            newP = P * exp(-newX*newX)/exp(-x[i]*x[i]);
            
            for(j=0;j<N;j++){
                if(i==j) continue;
                newP = newP * ((newX-x[j])*(newX-x[j]))/((x[i]-x[j])*(x[i]-x[j]));
            }
            if(P/newP <= 1 | ran2(&idum) <= newP/P){
                compteur = compteur + 1;
                x[i] = newX ;
                P = newP ;
            }
        }
        
        //GRILLE//
        //On fait plusieurs grilles pour connaître les moyennes et écart-types//
        // If N=2 on cherche l'histogramme de la densité de proba//
        
        if(k>nbredefois/10){ //thermalisation de 10%
            
            if(k<taillegrilles+nbredefois/10){
                for(i=0;i<L;i++){
                    if(-4+i*pas <= x[0] && x[0] <= -4+(i+1)*pas){
                        numeroX0 = i;
                    }
                }
                
                for(i=0;i<L;i++){
                    if(4-i*pas >= x[1] && x[1] >= 4-(i+1)*pas){
                        numeroX1 = i;
                    }
                }
                
                grille1[numeroX0][numeroX1] = grille1[numeroX0][numeroX1] + 1;

                
            }//endif grille 1
            
            else if(k<2*taillegrilles+nbredefois/10){
                for(i=0;i<L;i++){
                    if(-4+i*pas <= x[0] && x[0] <= -4+(i+1)*pas){
                        numeroX0 = i;
                    }
                }
                
                for(i=0;i<L;i++){
                    if(4-i*pas >= x[1] && x[1] >= 4-(i+1)*pas){
                        numeroX1 = i;
                    }
                }
                
                grille2[numeroX0][numeroX1] = grille2[numeroX0][numeroX1] + 1;
                
                
            }//endif grille 2
            
            else if(k<3*taillegrilles+nbredefois/10){
                for(i=0;i<L;i++){
                    if(-4+i*pas <= x[0] && x[0] <= -4+(i+1)*pas){
                        numeroX0 = i;
                    }
                }
                
                for(i=0;i<L;i++){
                    if(4-i*pas >= x[1] && x[1] >= 4-(i+1)*pas){
                        numeroX1 = i;
                    }
                }
                
                grille3[numeroX0][numeroX1] = grille3[numeroX0][numeroX1] + 1;
                
                
            }//endif grille 3
            
            else if(k<4*taillegrilles+nbredefois/10){
                for(i=0;i<L;i++){
                    if(-4+i*pas <= x[0] && x[0] <= -4+(i+1)*pas){
                        numeroX0 = i;
                    }
                }
                
                for(i=0;i<L;i++){
                    if(4-i*pas >= x[1] && x[1] >= 4-(i+1)*pas){
                        numeroX1 = i;
                    }
                }
                
                grille4[numeroX0][numeroX1] = grille4[numeroX0][numeroX1] + 1;
                
                
            }//endif grille 4
            
            else if(k<5*taillegrilles+nbredefois/10){
                for(i=0;i<L;i++){
                    if(-4+i*pas <= x[0] && x[0] <= -4+(i+1)*pas){
                        numeroX0 = i;
                    }
                }
                
                for(i=0;i<L;i++){
                    if(4-i*pas >= x[1] && x[1] >= 4-(i+1)*pas){
                        numeroX1 = i;
                    }
                }
                
                grille5[numeroX0][numeroX1] = grille5[numeroX0][numeroX1] + 1;
                
                
            }//endif grille 5
            
            else if(k<6*taillegrilles+nbredefois/10){
                for(i=0;i<L;i++){
                    if(-4+i*pas <= x[0] && x[0] <= -4+(i+1)*pas){
                        numeroX0 = i;
                    }
                }
                
                for(i=0;i<L;i++){
                    if(4-i*pas >= x[1] && x[1] >= 4-(i+1)*pas){
                        numeroX1 = i;
                    }
                }
                
                grille6[numeroX0][numeroX1] = grille6[numeroX0][numeroX1] + 1;
                
                
            }//endif grille 6
            
            else if(k<7*taillegrilles+nbredefois/10){
                for(i=0;i<L;i++){
                    if(-4+i*pas <= x[0] && x[0] <= -4+(i+1)*pas){
                        numeroX0 = i;
                    }
                }
                
                for(i=0;i<L;i++){
                    if(4-i*pas >= x[1] && x[1] >= 4-(i+1)*pas){
                        numeroX1 = i;
                    }
                }
                
                grille7[numeroX0][numeroX1] = grille7[numeroX0][numeroX1] + 1;
                
                
            }//endif grille 7
            
            else if(k<8*taillegrilles+nbredefois/10){
                for(i=0;i<L;i++){
                    if(-4+i*pas <= x[0] && x[0] <= -4+(i+1)*pas){
                        numeroX0 = i;
                    }
                }
                
                for(i=0;i<L;i++){
                    if(4-i*pas >= x[1] && x[1] >= 4-(i+1)*pas){
                        numeroX1 = i;
                    }
                }
                
                grille8[numeroX0][numeroX1] = grille8[numeroX0][numeroX1] + 1;
                
                
            }//endif grille 8
            
            else if(k<9*taillegrilles+nbredefois/10){
                for(i=0;i<L;i++){
                    if(-4+i*pas <= x[0] && x[0] <= -4+(i+1)*pas){
                        numeroX0 = i;
                    }
                }
                
                for(i=0;i<L;i++){
                    if(4-i*pas >= x[1] && x[1] >= 4-(i+1)*pas){
                        numeroX1 = i;
                    }
                }
                
                grille9[numeroX0][numeroX1] = grille9[numeroX0][numeroX1] + 1;
                
                
            }//endif grille 9
            
            else {
                for(i=0;i<L;i++){
                    if(-4+i*pas <= x[0] && x[0] <= -4+(i+1)*pas){
                        numeroX0 = i;
                    }
                }
                
                for(i=0;i<L;i++){
                    if(4-i*pas >= x[1] && x[1] >= 4-(i+1)*pas){
                        numeroX1 = i;
                    }
                }
                
                grille10[numeroX0][numeroX1] = grille10[numeroX0][numeroX1] + 1;
                
                
            }//endif grille 10
            
            
        }//endif therma
        
    }//endfor k

        
            
            
            printf("stat d'acceptation de config : %f\n", 1.0*compteur/N/nbredefois);
    
    
    //GRILLE//
    //NORMALISATION//
    for(i=0 ; i<L ; i++){
        for(j=0;j<L;j++){
            grille1[i][j]= grille1[i][j]/taillegrilles/pas/pas;
            grille2[i][j]= grille2[i][j]/taillegrilles/pas/pas;
            grille3[i][j]= grille3[i][j]/taillegrilles/pas/pas;
            grille4[i][j]= grille4[i][j]/taillegrilles/pas/pas;
            grille5[i][j]= grille5[i][j]/taillegrilles/pas/pas;
            grille6[i][j]= grille6[i][j]/taillegrilles/pas/pas;
            grille7[i][j]= grille7[i][j]/taillegrilles/pas/pas;
            grille8[i][j]= grille8[i][j]/taillegrilles/pas/pas;
            grille9[i][j]= grille9[i][j]/taillegrilles/pas/pas;
            grille10[i][j]= grille10[i][j]/taillegrilles/pas/pas;
        }
    }
    
    /*
    for(i=0;i<L;i++){
        for(j=0;j<L;j++){
            fprintf(pf9,"%f ", grille1[i][j]);
            fprintf(pf10,"%f ", grille2[i][j]);
            fprintf(pf11,"%f ", grille3[i][j]);
            fprintf(pf12,"%f ", grille4[i][j]);
            fprintf(pf13,"%f ", grille5[i][j]);
            fprintf(pf14,"%f ", grille6[i][j]);
            fprintf(pf15,"%f ", grille7[i][j]);
            fprintf(pf16,"%f ", grille8[i][j]);
            fprintf(pf17,"%f ", grille9[i][j]);
            fprintf(pf18,"%f ", grille10[i][j]);
        }
        fprintf(pf9,"\n");
        fprintf(pf10,"\n");
        fprintf(pf11,"\n");
        fprintf(pf12,"\n");
        fprintf(pf13,"\n");
        fprintf(pf14,"\n");
        fprintf(pf15,"\n");
        fprintf(pf16,"\n");
        fprintf(pf17,"\n");
        fprintf(pf18,"\n");
        
    }
    */
    
    //Calcul des grilles moyenne et écart-type//
    
    
    for(i=0; i<L; i++){
        for(j=0; j<L; j++){
            grillemoy[i][j] = (grille1[i][j]+grille2[i][j]+grille3[i][j]+grille4[i][j]+grille5[i][j]+grille6[i][j]+grille7[i][j]+grille8[i][j]+grille9[i][j]+grille10[i][j])/10;
            
            moyennecarre = (grille1[i][j]*grille1[i][j]+grille2[i][j]*grille2[i][j]+grille3[i][j]*grille3[i][j]+grille4[i][j]*grille4[i][j]+grille5[i][j]*grille5[i][j]+grille6[i][j]*grille6[i][j]+grille7[i][j]*grille7[i][j]+grille8[i][j]*grille8[i][j]+grille9[i][j]*grille9[i][j]+grille10[i][j]*grille10[i][j])/10;
            grilleET[i][j] = sqrt((moyennecarre - grillemoy[i][j]*grillemoy[i][j])/10);
            
            
        }
    }
    
    
    for(i=0;i<L;i++){
        for(j=0;j<L;j++){
            fprintf(pf19,"%f ", grillemoy[i][j]);
            fprintf(pf20,"%f ", grilleET[i][j]);
        }
        fprintf(pf19,"\n");
        fprintf(pf20,"\n");
    }
    
    
    for(i=0;i<L;i++){
        for(j=0;j<L;j++){
            if(j==i){
                fprintf(pf21,"%f %f %f\n", (-4+j*pas-4+(j+1)*pas)/2, grillemoy[i][j], grilleET[i][j]); //printf (x, grillemoyenne,incertitudes)
                incertmoy = incertmoy + grilleET[i][j]; // moyenne des incertitudes absolues //
                if(grillemoy[i][j]!=0 && grillemoy[i][j]>0.001){
                    incertmoypourcent = incertmoypourcent + grilleET[i][j]/grillemoy[i][j]; // moyenne des incertitudes relatives //
                }
                
                
            }
        }
    }
    
    //Courbe Theorique Densite x1=-x2//
    for(i=0;i<L;i++){
        xy = (-4+i*pas-4+(i+1)*pas)/2;
        
        fprintf(pf7,"%f %f\n", xy,4.0*xy*xy*exp(-2.0*xy*xy)/M_PI);
        
    }
    
    fclose(pf7);
    fclose(pf21);
    
    pf7 = fopen("courbetheorique.txt","r");
    pf21 = fopen("coupeincert.txt","r");
    
    for(i=0; i<L; i++){
        
        fscanf(pf7,"%*lf %lf \n",&fctx[i]);
        fscanf(pf21,"%*lf %lf %*lf \n",&fctxexp[i]);
        
        fctmoy = fctmoy + fabs(fctxexp[i]-fctx[i]);
        

    }
    fclose(pf7);
    fclose(pf21);
    
    printf("incertitude moyenne statistique : %f\n différence moyenne théorie/expérience : %lf\n moyenne des incertitudes relatives (en pourcent) : %f\n",incertmoy/L, fctmoy/L, incertmoypourcent*100.0/L);
    
    
    
    

    
    fclose(pf9);
    fclose(pf10);
    fclose(pf11);
    fclose(pf12);
    fclose(pf13);
    fclose(pf14);
    fclose(pf15);
    fclose(pf16);
    fclose(pf17);
    fclose(pf18);
    fclose(pf19);
    fclose(pf20);
    
    
    
    
    
}//end main