#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>

FILE *pf8;

float ran2(long int*);
int i,j,k,a,N = 4, nbredefois = 100000 ;
int compteur,compteurk;
int iout, mod;
int L = 51; //sur un intervalle de [-4,4]

double P, newP, newX, intervalle;
long int idum = -1833;

int numeroX0, numeroX1;
double pas;

int main() {
    
    pf8 = fopen("trajtherma.txt","w");
    
    
    double x[N];
    
    compteur = 0;
    
    
    
    
    //Distribution initiale des particules//
    x[0] = -10.0;
    for(i=1;i<N;i++){
        x[i]= x[i-1] - 2.0*x[0]/(N-1);
        printf("%f\n",x[i]);
    }
    
    
    //Calcul de la proba de la config initiale//
    
    P = 1; //initialisation de la proba
    for(i=0;i<N;i++){
        for(j=i+1;j<N;j++){
            P = P * (x[i]-x[j]) * (x[i]-x[j]);
        }
        P = P * exp(-x[i]*x[i]);
    }
    
    //Calcul des nouvelles proba avec nouvelles config//
    
    for(k=0;k<nbredefois;k++){
        for(i=0;i<N;i++){

            
            newX = x[i] + 2*(ran2(&idum))-1;
            newP = P * exp(-newX*newX)/exp(-x[i]*x[i]);

            for(j=0;j<N;j++){
                if(i==j) continue;
                newP = newP * ((newX-x[j])*(newX-x[j]))/((x[i]-x[j])*(x[i]-x[j]));
            }
            //thermalisation//
            
            if(P/newP <= 1 | ran2(&idum) <= newP/P){
                compteur = compteur + 1;
                x[i] = newX ;
                P = newP ;
                
            }
        }
        
        
        //TRAJ CLASSIQUE + Thermalisation//
        //if(k%10==0){
        if(k<=1000) {
            for(i=0 ; i<N ; i++){
                fprintf(pf8,"%f ",x[i]);
            }
            fprintf(pf8,"%d\n",k);
            
            

        }
        
        //}
        
    }//endfor k
    printf("stat d'acceptation de config : %f\n", 1.0*compteur/N/nbredefois);
    
    fclose(pf8);
    
}//end main


/* pour ne pas que la thermalisationn influence le résultat, on prend les mesures à partir de 10% de k i.e. :

 if(k>0.1*nbredefois){
}
*/